#include <stdio.h>
#include <iostream>
#include <iomanip>
#include "Graph.h"

using namespace std;

Graph::Graph(char *pFileName) {
  FILE *fin;
  
  if((fin = fopen(pFileName, "r")) == NULL) {
    cout << "Chyba: Soubor " << pFileName << " se nepodarilo otevrit" << endl;
    exit(1);
  }

  fscanf(fin, "%d\n", &nodes);

  if(nodes < 2) {
    cout << "Chyba: Je zadan nedostatecny pocet vrcholu (" << nodes << ")" << endl;
    exit(1);
  }

  graph = new int *[nodes];
  for(int i = 0; i < nodes; i++) graph[i] = new int [nodes];

  edges = 0;
  char line[2 * nodes + 3];
  
  for(int i = 0; i < nodes; i++) {
    fgets(line, 2 * nodes + 3, fin);

    for(int j = 0; j < nodes; j++) {
      if(j >= i) {
        if(line[2 * j] == '0') graph[i][j] = 0;
        else graph[i][j] = ++edges;
      }
      else {
        if(line[2 * j] != '0') {
          if(graph[j][i] == 0) {
            cout << "Chyba: Mezi uzly " << (i + 1) << " a " << (j + 1) << " nema byt hrana" << endl;
            exit(1);
          }
	  else graph[i][j] = graph[j][i];
        }
	else {
          if(graph[j][i] > 0) {
            cout << "Chyba: Mezi uzly " << (i + 1) << " a " << (j + 1) << " ma byt hrana" << endl;
            exit(1);
          }
	  else graph[i][j] = 0;
        }
      }
    }
  }

  fclose(fin);
  printGraph();
}

Graph::Graph(int pNodes, bool **pGraph) {
  nodes = pNodes;
  edges = 0;
  graph = new int *[nodes];
  for(int i = 0; i < nodes; i++) graph[i] = new int [nodes];

  for(int i = 0; i < nodes; i++) {
    for(int j = 0; j < nodes; j++) {
      if(j >= i) {
        if(pGraph[i][j]) graph[i][j] = ++edges;
        else graph[i][j] = 0;
      }
      else graph[i][j] = graph[j][i];
    }
  }

  printGraph();
}

bool **Graph::getGraph() {
  bool **res = new bool *[nodes];
  for(int i = 0; i < nodes; i++) res[i] = new bool [nodes];
  
  for(int i = 0; i < nodes; i++)
    for(int j = 0; j < nodes; j++)
      res[i][j] = (graph[i][j] != 0);

  return res;
}

void Graph::getNeighbours(int pNode, bool *pEdges, int *pRes) {
  int count = 0;

  for(int i = 0; i < nodes; i++)
    if(graph[pNode][i] > 0 && pEdges[graph[pNode][i] - 1]) pRes[count++] = i;

  for(int i = count; i < (nodes + 1); i++) pRes[i] = NEIGH_EMPTY;
}

void Graph::printGraph() {
  for(int i = 0; i < nodes; i++) {
    for(int j = 0; j < nodes; j++)
      cout << setw(3) << graph[i][j];
    
    cout << endl;
  }

  cout << endl;
}

void Graph::print(bool *pEdges) {
  for(int i = 0; i < nodes; i++) {
    for(int j = 0; j < nodes; j++)
      if(graph[i][j] && pEdges[graph[i][j] - 1]) cout << setw(3) << "1";
      else cout << setw(3) << "0";

    cout << endl;
  }
}

Graph::~Graph() {
  for(int i = 0; i < nodes; i++) delete [] graph[i];
  delete [] graph;
}

